--[==[

Title AdventureJournal 
Author [Deathsage@Pyrewood Village]

The MIT License Copyright (c) 2019 S.T.Pain Permission is hereby granted,
free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, 
including without limitation the rights to use, copy, modify, merge, publish, distribute, 
sublicense, and/or sell copies of the Software, and to permit persons to whom the 
Software is furnished to do so, subject to the following conditions: The above copyright 
notice and this permission notice shall be included in all copies or substantial portions
of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.

]==]--

local name, AJ = ...


-- TODO tidy all variables and organise file layout, maybe move some util func into new file
AJ.VarsLoaded = false
AJ.WorldMapUpdate = false
AJ.NodeGUIDsCreated = {}
AJ.FishingCast = false

local HBD = LibStub("HereBeDragons-2.0")
local Pins = LibStub("HereBeDragons-Pins-2.0")

SLASH_ADVENTUREJOURNAL1 = '/adj'
SlashCmdList['ADVENTUREJOURNAL'] = function(msg)
	if msg == 'test' then
		print('test')

	elseif msg == 'purge-loot' then
		StaticPopup_Show ("AdventureJournal_PurgeLootDialog")

	elseif msg == 'fix-loot' then
		StaticPopup_Show ("AdventureJournal_FixLootDb")

	end

end

AJ.RecentCombatTargets = {}
AJ.loot = {}
AJ.LootSearchTable = {}

AJ.MapNodeCacheMinimap = {}
AJ.MapNodeCacheWorldmap = {}

AJ.NotesItemTitle = { 
	['quest'] = '|cff005100 Quest accepted |r',
	['note'] = '|cff510000',
	['discovered'] = '|cff003366 ',
	['quest-completed'] = '|cff46008a Quest completed |r'
}

AJ.FishingSpells = { 271616, 272011, 271675, 271672, 271658, 271656, 271662, 271677, 131490, 131476, 131474, 7620, 158743, 1104110, 88868, 51294, 33095, 18248, 7732, 7731, 271664, 271660 }
AJ.SpellID = { 2575, 2576, 3564, 10248, 29354, 50310, 74517, 102161, 158754, 195122, 265837, 2366, 2368, 3570, 11993, 28695, 50300, 74519, 110413, 158745, 195114, 265819, 3365 }
AJ.MinimapScales = { [0] = 7.0, [1] = 9.0, [2] = 11.5, [3] = 14.0, [4] = 18.0, [5] = 27.0 }

AJ.ClassColours = {
	DEATHKNIGHT = { r = 0.77, g = 0.12, b = 0.23, fs = '|cffC41F3B' },
	DRUID = { r = 1.00, g = 0.49, b = 0.04, fs = '|cffFF7D0A' },
	HUNTER = { r = 0.67, g = 0.83, b = 0.45, fs = '|cffABD473' },
	MAGE = { r = 0.25, g = 0.78, b = 0.92, fs = '|cff40C7EB' },
	PALADIN = { r = 0.96, g = 0.55, b = 0.73, fs = '|cffF58CBA' },
	PRIEST = { r = 1.00, g = 1.00, b = 1.00, fs = '|cffFFFFFF' },
	ROGUE = { r = 1.00, g = 0.96, b = 0.41, fs = '|cffFFF569' },
	SHAMAN = { r = 0.00, g = 0.44, b = 0.87, fs = '|cff0070DE' },
	WARLOCK = { r = 0.53, g = 0.53, b =	0.93, fs = '|cff8787ED' },
	WARRIOR = { r = 0.78, g = 0.61, b = 0.43, fs = '|cffC79C6E' },
	Total = { r = 1, g = 1, b = 1 }
}

--[==[
AJ.minimap = CreateFrame("Button", "AJ_MinimapButton", Minimap);
AJ.minimap:EnableMouse(true);
AJ.minimap:SetMovable(true);
AJ.minimap:SetSize(33, 33);
AJ.minimap:SetPoint("TOPLEFT");
AJ.minimap:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
AJ.minimap:RegisterForClicks("LeftButtonUp", "RightButtonUp");
AJ.minimap:RegisterForDrag("LeftButton");
AJ.minimap:SetScript('OnClick', function() print('clcik') end)

AJ.minimap.t = AJ.minimap:CreateTexture("$parent_minimapButtonBorder", "OVERLAY");
AJ.minimap.t:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
AJ.minimap.t:SetSize(56, 56);
AJ.minimap.t:SetPoint("TOPLEFT");

AJ.minimap.tb = AJ.minimap:CreateTexture("$parent_minimapButtonIcon", "background");
AJ.minimap.tb:SetTexture("Interface\\Icons\\inv_misc_spyglass_02")
AJ.minimap.tb:SetSize(21, 21);
AJ.minimap.tb:SetPoint("CENTER");

AJ.minimapFrame = CreateFrame("FRAME", 'minimapFrame', AJ.minimap);
AJ.minimapFrame:SetScript("OnUpdate", function()
    local xpos, ypos = GetCursorPosition()
    local xmin, ymin = Minimap:GetLeft(), Minimap:GetBottom()

    xpos = xmin - xpos / UIParent:GetScale() + 70 -- get coordinates as differences from the center of the minimap
    ypos = ypos / UIParent:GetScale() - ymin - 70

    AJ_GlobalVariables.Settings.MinimapButtonPos = math.deg(math.atan2(ypos, xpos))
    AJ.updateMiniMapPosition()
end);
AJ.minimapFrame:Hide();

AJ.minimap:SetScript("OnDragStart", function(self)
    --self:LockHighlight();
    AJ.minimapFrame:Show();
end);

AJ.minimap:SetScript("OnDragStop", function(self)
    --self:UnlockHighlight();
    AJ.minimapFrame:Hide();
end);

function AJ.updateMiniMapPosition()
    AJ.minimap:SetPoint("TOPLEFT", "Minimap", "TOPLEFT", 52 - (80 * cos(AJ_GlobalVariables.Settings.MinimapButtonPos)), (80 * sin(AJ_GlobalVariables.Settings.MinimapButtonPos)) - 52)
end

]==]--

StaticPopupDialogs["AdventureJournal_PurgeLootDialog"] = {
	text = "Remove all loot from your journal?.",
	button1 = "Ok",
	button2 = 'Cancel',
	OnAccept = function(self) AJ_GlobalVariables.Loot = {} AJ.Print('all loot removed from journal') end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
}

-- not used yet
StaticPopupDialogs["AdventureJournal_FixLootDb"] = {
	text = "Attempt to fix any errors in the journals loot database?.",
	button1 = "Ok",
	button2 = 'Cancel',
	OnAccept = function(self) 
		for k, loot in pairs(AJ_GlobalVariables.Loot) do
			if loot.SourceName == nil then loot.SourceName = 'Unknown' end
		end
		for k, loot in pairs(AJ_GlobalVariables.GameObjects) do
			if loot.SourceName == nil then loot.SourceName = 'Unknown' end
		end
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
}

-- need to check apple formatting
function AJ.GetDateFormatted(dateObj)
	if not dateObj then
		if IsWindowsClient() then
			return date("%d %B %Y")
		elseif IsLinuxClient() then
			return date("%a %b %d")
		end
	else
		if IsWindowsClient() then
			return date("%d %B %Y", time(dateObj))
		elseif IsLinuxClient() then
			return date("%a %b %d", time(dateObj))
		end
	end
end

function AJ.MakeFrameMove(frame)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end

function AJ.GetArgs(...)
	for i=1, select("#", ...) do
		arg = select(i, ...)
		print(i.." "..tostring(arg))
	end
end

function AJ.Print(msg, override)
	--if ForagerGlobalSettings[UnitGUID('player')].PrintForagerInfo == true or override == true then
		print('|cff00FF96Adventure Journal: |r'..msg)	
	--end
end

function AJ.PrintMoney(msg, money)
	print('|cff00FF96Adventure Journal: |r'..msg..' '..GetCoinTextureString(money))
end

-- change to tabe object rather than using globals
function AJ.CLearLootListView()
	for i = 1, 10 do
		AJ.LootListViewItems[i].ItemName:SetText('')
		AJ.LootListViewItems[i].ItemZone:SetText('')
		AJ.LootListViewItems[i].ItemSource:SetText('')
		AJ.LootListViewItems[i]:Hide()
	end
end

-- change to tabe object rather than using globals
function AJ.ClearNotesListView()
	for i = 1, 10 do
		if _G["NotesListViewItem"..i] then
			_G["NotesListViewItem"..i].NoteText:SetText('')
			_G["NotesListViewItem"..i].NoteTime:SetText('')
			_G["NotesListViewItem"..i]:Hide()
		end
	end
end

function AJ.CLearBagListView()
	for i = 1, 20 do
		AJ.BagFrameListViewItems[i].ItemName:SetText('')
		AJ.BagFrameListViewItems[i].ItemType:SetText('')
		AJ.BagFrameListViewItems[i].ItemCount:SetText('')
		AJ.BagFrameListViewItems[i]:Hide()
	end
end

function AJ.SellJunk()
	if MerchantFrame:IsVisible() then
		local sold_value = 0
		local sold_items = 0
		local sales = {}
		for bag = 0, 4 do
			for slot = 1, GetContainerNumSlots(bag) do 
				local item_link = GetContainerItemLink(bag,slot) 
				if item_link and select(3, GetItemInfo(item_link)) == 0 then

					-- get item data
					item_count = select(2, GetContainerItemInfo(bag, slot))
					sold_items = sold_items + item_count
					sold_value = sold_value + (item_count * select(11, GetItemInfo(item_link)))

					--update local table
					if sales == nil then
						table.insert(sales, { link = item_link, count = item_count, cost = select(11, GetItemInfo(item_link)) })
					else
						local added = false
						for k, item in ipairs(sales) do
							if item.link == item_link then 
								item.count = item.count + item_count
								added = true
							end
						end
						if added == false then
							table.insert(sales, { link = item_link, count = item_count, cost = select(11, GetItemInfo(item_link)) })
						end
					end					
					-- sell item
					UseContainerItem(bag,slot)
				end
			end
		end
	
		-- print sell info check
		if 1 == 1 then
			for k, item in ipairs(sales) do
				AJ.PrintMoney('sold '..item.count..' '..item.link..' for ', tonumber(item.count * item.cost))
			end
		end
		AJ.PrintMoney(tostring('sold '..tostring(sold_items)..' for '), tonumber(sold_value))
	end
end


function AJ.AddNote(noteType, noteText, questID)
	if AJ.VarsLoaded == true then
		--get map data
		local map = C_Map.GetBestMapForUnit('player')
		local currentMapPosition = C_Map.GetPlayerMapPosition(map, 'player')
		local currentMapName = C_Map.GetMapInfo(map).name

		if currentMapPosition then
			table.insert(AJ_GlobalVariables.Notes[UnitGUID('player')], { Type = noteType, Note = noteText, Date = date("*t"), QuestID = questID, MapZoneName = currentMapName, MapZonePosX = currentMapPosition.x, MapZonePosY = currentMapPosition.y })
		else
			table.insert(AJ_GlobalVariables.Notes[UnitGUID('player')], { Type = noteType, Note = noteText, Date = date("*t"), QuestID = questID, MapZoneName = 'unknown', MapZonePosX = 'unknown', MapZonePosY = 'unknown' })
		end
		if noteType == 'note' then
			--AJ.Print('add new note to journal')
		else
			--AJ.Print('add new entry to journal')
		end
	end
end

function AJ.IsNodeInRange(myPosX, myPosY, nodePosX, nodePosY)
	if type(nodePosX) == 'number' then
		local distance = (((myPosX - nodePosX)^2.0) + ((myPosY - nodePosY)^2.0)) ^ 0.5
		if distance < 0.0025 then
			--print(distance * 140)
			return true
		else
			return false
		end
	end
end

function AJ.IsNodeInRangeMinimap(myPosX, myPosY, nodePosX, nodePosY)
	if type(nodePosX) == 'number' then
		local distance = (((myPosX - nodePosX)^2.0) + ((myPosY - nodePosY)^2.0)) ^ 0.5
		distance = distance * 140
		local zoom = Minimap:GetZoom()
		if zoom == 5 then
			if distance < 1.8 then
				return true
			else
				return false
			end
		elseif zoom == 4 then
			if distance < 2.4 then
				return true
			else
				return false
			end
		elseif zoom == 3 then
			if distance < 3.0 then
				return true
			else
				return false
			end
		elseif zoom == 2 then
			if distance < 3.8 then
				return true
			else
				return false
			end
		elseif zoom == 1 then
			if distance < 5.0 then
				return true
			else
				return false
			end
		elseif zoom == 0 then
			if distance < 6.0 then
				return true
			else
				return false
			end
		end
	end
end

function AJ.HideMinimapPins()
	for i, j in pairs(AJ.MapNodeCacheMinimap) do  
		if AJ.MapNodeCacheMinimap[i] then
			AJ.MapNodeCacheMinimap[i]:Hide()
		end
	end
end

function AJ.HideWorldMapPins()
	for i, j in pairs(AJ.MapNodeCacheWorldmap) do
		if AJ.MapNodeCacheWorldmap[i] then
			AJ.MapNodeCacheWorldmap[i]:Hide()
		end
	end
end

function AJ.DrawMapNodeIconMinimap(f, x, y, w, h, level, strata, icon)

	f:SetPoint("CENTER", x, y)
	f:SetSize(w, h)
	f:SetFrameLevel(level)
	f:SetFrameStrata(strata)
	f:EnableKeyboard(true)
	f:SetPropagateKeyboardInput(true)
	
	f.texture = f:CreateTexture(nil, 'ARTWORK')
	f.texture:SetAllPoints(f)
	f.texture:SetTexture(icon)
end

-- clunky
AJ.WorldMapFrameUpdateButton = CreateFrame("BUTTON", "AJ_WorldMapFrameUpdateButton", WorldMapFrame.BorderFrame, "UIPanelButtonTemplate")
AJ.WorldMapFrameUpdateButton:SetPoint("TOPLEFT", 100, -4)
AJ.WorldMapFrameUpdateButton:SetSize(60, 22)
AJ.WorldMapFrameUpdateButton:SetText("Refresh")
AJ.WorldMapFrameUpdateButton:SetScript("OnClick", function() AJ.WorldMapUpdate = true AJ.UpdateWorldMapPins() end)

--going to re work this over time to really improve performance, get map data once in the onUpdate
function AJ.UpdateWorldMapPins()

	if AJ.VarsLoaded == true and AJ.WorldMapUpdate == true and WorldMapFrame:IsVisible() and AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayWorldMapIcons == true then

		local key = 1
		AJ.NodeGUIDsCreated = {}

		for k, loot in pairs(AJ_GlobalVariables.GameObjects) do

			if loot and loot.MapZoneName == C_Map.GetMapInfo(WorldMapFrame:GetMapID()).name then
				
				--print(loot.Name, loot.MapZoneName)

				if AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] and AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] == true then

					if AJ.NodeGUIDsCreated[loot.SourceGUID] == true then

						--print(loot.SourceName, 'exists already')
					else
						--print(loot.SourceName, 'new')
						
						local x, y, instance = HBD:GetWorldCoordinatesFromZone(loot.MapZonePosX, loot.MapZonePosY, loot.MapID)

						if AJ.MapNodeCacheWorldmap[key] == nil then
					
							AJ.NodeGUIDsCreated[loot.SourceGUID] = true

							--print('creating new node icon', loot.Name, key, string.format("%.4f",loot.MapZonePosX * 100), string.format("%.4f",loot.MapZonePosY * 100))

							local f = CreateFrame("FRAME", "AJ_Pin"..key, UIParent)
							f:SetSize(tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize))
							f.texture = f:CreateTexture(nil, 'ARTWORK')
							f.texture:SetAllPoints(f)
							f.texture:SetTexture(loot.IconID)

							AJ.MapNodeCacheWorldmap[key] = f

							--Pins:AddMinimapIconWorld("AdventureJournal", f, instance, x, y, false)
				
							Pins:AddWorldMapIconWorld("AdventureJournal", f, instance, x, y)

						else
							--print('found node', key, loot.Name, string.format("%.4f",loot.MapZonePosX * 100), string.format("%.4f",loot.MapZonePosY * 100))
							AJ.MapNodeCacheWorldmap[key].texture:SetTexture(loot.IconID)
							AJ.MapNodeCacheWorldmap[key]:SetSize(tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize))
							AJ.MapNodeCacheWorldmap[key]:Show()
							Pins:AddWorldMapIconWorld("AdventureJournal", AJ.MapNodeCacheWorldmap[key], instance, x, y)
							AJ.NodeGUIDsCreated[loot.SourceGUID] = true
						end
						key = key + 1
					end
				else
					AJ.HideWorldMapPins()
				end
			else

			end
		end
		AJ.WorldMapUpdate = false
	end
end

--------------------------------------------------------------------------------------------------
--borrowed from online

local GetBestMapForUnit = C_Map.GetBestMapForUnit   
local MapRects =  {}
local mapID
local UnitPosition =  UnitPosition
local GetWorldPosFromMapPos =  C_Map.GetWorldPosFromMapPos
local CreateVector2D =  CreateVector2D
 
function AJ.GetPlayerMapPosition(mapid, token, rects, _, x, y)
    if mapid then
        rects = MapRects[mapid]
        if not rects then
            rects = {}
            _, topleft = GetWorldPosFromMapPos(mapid, CreateVector2D(0,0))
            _, bottomright = GetWorldPosFromMapPos(mapid, CreateVector2D(1,1))
 
            bottomright:Subtract(topleft)
            rects = { topleft.x, topleft.y, bottomright.x, bottomright.y }
            MapRects[mapid] = rects
        end
 
        x, y = UnitPosition(token)
        if x then
            x, y = x - rects[1], y - rects[2]
            return y / rects[4], x / rects[3]
        else
            return 0, 0
        end
    end
end
--------------------------------------------------------------------------------------------------

--this is a massive perfrmance issue, potential help with a sinlge map data request however it may prove better to draw all frames rather than recycle

function AJ.UpdateMiniMapPins()
	AJ.HideMinimapPins()
	if AJ.VarsLoaded == true and AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayMinimapIcons == true then

		AJ.CurrentMapID = C_Map.GetBestMapForUnit('player')
		if not AJ.CurrentMapID then
			return
		else
			--AJ.CurrentMapPosition = C_Map.GetPlayerMapPosition(AJ.CurrentMapID, 'player')
			local key = 1
			AJ.MinimapNodeGUIDsCreated = {}

			for k, loot in pairs(AJ_GlobalVariables.GameObjects) do

				if loot and loot.MapZoneName == C_Map.GetMapInfo(AJ.CurrentMapID).name then
				
					--print(loot.Name, loot.MapZoneName)

					if AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] and AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] == true then

						if AJ.MinimapNodeGUIDsCreated[loot.SourceGUID] == true then

							--print(loot.SourceName, 'exists already')
						else
							--print(loot.SourceName, 'new')

							local x, y, instance = HBD:GetWorldCoordinatesFromZone(loot.MapZonePosX, loot.MapZonePosY, loot.MapID)

							if AJ.MapNodeCacheMinimap[key] == nil then
					
								AJ.MinimapNodeGUIDsCreated[loot.SourceGUID] = true

								--print('creating new node icon', loot.Name, key, string.format("%.4f",loot.MapZonePosX * 100), string.format("%.4f",loot.MapZonePosY * 100))

								local f = CreateFrame("FRAME", "AJ_Pin"..key, UIParent)
								f:SetSize(tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize))
								f.texture = f:CreateTexture(nil, 'ARTWORK')
								f.texture:SetAllPoints(f)
								f.texture:SetTexture(loot.IconID)

								AJ.MapNodeCacheMinimap[key] = f
								AJ.MapNodeCacheMinimap[key]:SetScript('OnEnter', function()
									AJ.MinimapNodeTooltip:Show()
									AJ.MinimapNodeTooltip.NodeSourceText:SetText(loot.SourceName)
									AJ.MinimapNodeTooltip:SetWidth(AJ.MinimapNodeTooltip.NodeSourceText:GetStringWidth() + 20)
								end)
								AJ.MapNodeCacheMinimap[key]:SetScript('OnLeave', function()
									AJ.MinimapNodeTooltip:Hide()
								end)

								Pins:AddMinimapIconWorld("AdventureJournal", f, instance, x, y, false)
				
								--Pins:AddWorldMapIconWorld("AdventureJournal", f, instance, x, y)

							else
								--print('found node', key, loot.Name, string.format("%.4f",loot.MapZonePosX * 100), string.format("%.4f",loot.MapZonePosY * 100))
								AJ.MapNodeCacheMinimap[key].texture:SetTexture(loot.IconID)
								AJ.MapNodeCacheMinimap[key]:SetSize(tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize))
								AJ.MapNodeCacheMinimap[key]:SetScript('OnEnter', function()
									AJ.MinimapNodeTooltip:Show()
									AJ.MinimapNodeTooltip.NodeSourceText:SetText(loot.SourceName)
									AJ.MinimapNodeTooltip:SetWidth(AJ.MinimapNodeTooltip.NodeSourceText:GetStringWidth() + 20)
								end)
								AJ.MapNodeCacheMinimap[key]:SetScript('OnLeave', function()
									AJ.MinimapNodeTooltip:Hide()
								end)
								--local _x, _y = AJ.GetPlayerMapPosition(AJ.CurrentMapID, 'player')
								--if AJ.IsNodeInRangeMinimap(_x, _y, loot.MapZonePosX, loot.MapZonePosY) then
								if AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] == false then
									print('hide', lot.SourceName)
									AJ.MapNodeCacheMinimap[key]:Hide()
								else
									--print('show')
									--AJ.MapNodeCacheMinimap[key]:Show()
									Pins:AddMinimapIconWorld("AdventureJournal", AJ.MapNodeCacheMinimap[key], instance, x, y, false)
								end

								--Pins:AddWorldMapIconWorld("AdventureJournal", AJ.MapNodeCacheWorldmap[key], instance, x, y)
--								Pins:AddMinimapIconWorld("AdventureJournal", AJ.MapNodeCacheMinimap[key], instance, x, y, false)
								AJ.MinimapNodeGUIDsCreated[loot.SourceGUID] = true
							end
							
							--local _x, _y = AJ.GetPlayerMapPosition(AJ.CurrentMapID, 'player')
							--if (((((_x * 140.0) - (loot.MapZonePosX * 140.0))^2.0) + (((_y * 140.0) - (loot.MapZonePosY * 140.0))^2.0)))^0.5 < tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].HideMinimapPinDistance) then
							key = key + 1
						end
					else
						AJ.HideMinimapPins()
					end
				else

				end
			end
		end
	else
	AJ.HideMinimapPins()
	end
end


--[==[
function AJ.UpdateMinimapPins()

	if AJ_GlobalVariables.Settings[UnitGUID('player')] and AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayMinimapIcons == true then

		local x, y = GetCursorPosition()
		local s = UIParent:GetEffectiveScale()
		local zoom = Minimap:GetZoom()

		--grab current position
		AJ.CurrentMapID = C_Map.GetBestMapForUnit('player')
		if not AJ.CurrentMapID then

			return
		else
		AJ.CurrentMapPosition = C_Map.GetPlayerMapPosition(AJ.CurrentMapID, 'player')
		AJ.CurrentMapName = C_Map.GetMapInfo(AJ.CurrentMapID).name
	
			if AJ.CurrentMapPosition ~= nil then

				if AJ_GlobalVariables ~= nil and AJ_GlobalVariables.Settings ~= nil and AJ_GlobalVariables.Settings[UnitGUID('player')] ~= nil and AJ_GlobalVariables.GameObjects ~= nil then
					for k, node in ipairs(AJ_GlobalVariables.GameObjects) do
					
						if node.MapZonePosX ~= 'Unknown' then
							if node.MapZoneName == AJ.CurrentMapName and string.find(node.SourceGUID, 'GameObject') and node.ItemTypeID == 7 then

								if AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[node.SourceName] and AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[node.SourceName] == true then

									if AJ.IsNodeInRangeMinimap(AJ.CurrentMapPosition.x, AJ.CurrentMapPosition.y, node.MapZonePosX, node.MapZonePosY) then

										local draw = true
							
										local xDiff = (AJ.CurrentMapPosition.x * 140.0) - (node.MapZonePosX * 140.0)
										local yDiff = (AJ.CurrentMapPosition.y * 140.0) - (node.MapZonePosY * 140.0)
							
										local distance = ((xDiff^2.0) + (yDiff^2.0))^0.5
							
										-- cretse first node
										if AJ.MapNodeCacheMinimap[k] == nil then
											local PinMinimap = CreateFrame('FRAME', 'AJMapNodePinMinimap'..k, Minimap)
											AJ.DrawMapNodeIconMinimap(PinMinimap, ((AJ.MinimapScales[zoom] * 2.0) * (xDiff * -1.0)), (AJ.MinimapScales[zoom] * yDiff), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), 4, 'FULLSCREEN_DIALOG', node.IconID)
											AJ.MapNodeCacheMinimap[k] = PinMinimap
											--AJ.MapNodeCacheMinimap[k].x = node.MapZonePosX
											--AJ.MapNodeCacheMinimap[k].y = node.MapZonePosY
											AJ.MapNodeCacheMinimap[k]:SetScript('OnEnter', function()
												AJ.MinimapNodeTooltip:Show()
												AJ.MinimapNodeTooltip.NodeSourceText:SetText(node.SourceName)
												AJ.MinimapNodeTooltip:SetWidth(AJ.MinimapNodeTooltip.NodeSourceText:GetStringWidth())
											end)
											AJ.MapNodeCacheMinimap[k]:SetScript('OnLeave', function()
												AJ.MinimapNodeTooltip:Hide()
											end)
										else
--[===[
											AJ.MapNodeCacheMinimap[k]:SetPoint('CENTER', (AJ.MinimapScales[zoom] * 1.1) * (xDiff * -1.0) , (AJ.MinimapScales[zoom] * 1.1) * yDiff )
											for k, p in pairs(AJ.MapNodeCacheMinimap) do
												if AJ.MapNodeCacheMinimap[k].x == node.MapZonePosX and AJ.MapNodeCacheMinimap[k].y == node.MapZonePosY then
													draw = false
												end
											end
										end
										if draw == true then
]===]--
											--AJ.MapNodeCacheMinimap[k].x = node.MapZonePosX
											--AJ.MapNodeCacheMinimap[k].y = node.MapZonePosY
											AJ.MapNodeCacheMinimap[k]:SetPoint('CENTER', (AJ.MinimapScales[zoom] * 1.5) * (xDiff * -1.0) , (AJ.MinimapScales[zoom] * 1.3) * yDiff )
											AJ.MapNodeCacheMinimap[k].texture:SetTexture(node.IconID)
											AJ.MapNodeCacheMinimap[k]:SetScript('OnEnter', function()
												AJ.MinimapNodeTooltip:Show()
												AJ.MinimapNodeTooltip.NodeSourceText:SetText(node.SourceName)
												AJ.MinimapNodeTooltip:SetWidth(AJ.MinimapNodeTooltip.NodeSourceText:GetStringWidth() + 20)
											end)
											AJ.MapNodeCacheMinimap[k]:SetScript('OnLeave', function()
												AJ.MinimapNodeTooltip:Hide()
											end)								
											AJ.MapNodeCacheMinimap[k]:Show()
											AJ.MapNodeCacheMinimap[k]:SetSize(tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize), tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize))
										end

										if distance < tonumber(AJ_GlobalVariables.Settings[UnitGUID('player')].HideMinimapPinDistance) then
											AJ.MapNodeCacheMinimap[k]:Hide()
										end
							
									else --?
										if AJ.MapNodeCacheMinimap[k] ~= nil then
											AJ.MapNodeCacheMinimap[k]:Hide()
										end
									end
								else
									AJ.HideMinimapPins()
								end
							end
						end
					end
				else
					--AJ.HideMinimapPins()
				end
			end
		end
	else
		AJ.HideMinimapPins()
	end
end
]==]--

function AJ.CreateMainTabButtons()
	AJ.MainTabButtons = {}
	local buttontext = { [1] = 'Notes', [2] = 'Loot', [3] = 'Bags'}
	for i = 1, 3 do
		AJ.MainTabButtons[i] = CreateFrame("BUTTON", '$parentTab'..i, AdventureJournal, 'CharacterFrameTabButtonTemplate')
		AJ.MainTabButtons[i]:SetPoint("BOTTOMLEFT", 60 * i, 60)
		AJ.MainTabButtons[i]:SetText(buttontext[i])
		AJ.MainTabButtons[i]:SetFrameStrata('BACKGROUND')
	end
	AJ.MainTabButtons[1]:SetFrameStrata('HIGH')
end

function AJ.DrawNotesPage()

	AJ.NotesDateDisplayed = date("*t")

	AJ.NotesPreviousDayButton = CreateFrame("BUTTON", "AJ_NotesPreviousDayButton", AdventureJournal_NotesFrame)
	AJ.NotesPreviousDayButton:SetPoint("TOPLEFT", 140, -39)
	AJ.NotesPreviousDayButton:SetSize(28, 28)
	AJ.NotesPreviousDayButton.texture = AJ.NotesPreviousDayButton:CreateTexture("$parent_Background", "ARTWORK")
	AJ.NotesPreviousDayButton.texture:SetAllPoints()
	AJ.NotesPreviousDayButton.texture:SetTexture("interface/buttons/ui-spellbookicon-prevpage-up")
	AJ.NotesPreviousDayButton:SetScript('OnMouseUp', function() 
		AJ.HeaderDateText:SetText(AJ.GetDateFormatted())
		AJ.NotesDateDisplayed = date("*t", time(AJ.NotesDateDisplayed) - (24*60*60))
		AJ.HeaderDateText:SetText(AJ.GetDateFormatted(AJ.NotesDateDisplayed))
		AJ_NotesFrameOnShow()
	end)

	AJ.NotesNextDayButton = CreateFrame("BUTTON", "AJ_NotesPreviousDayButton", AdventureJournal_NotesFrame)
	AJ.NotesNextDayButton:SetPoint("TOPLEFT", 320, -39)
	AJ.NotesNextDayButton:SetSize(28, 28)
	AJ.NotesNextDayButton.texture = AJ.NotesNextDayButton:CreateTexture("$parent_Background", "ARTWORK")
	AJ.NotesNextDayButton.texture:SetAllPoints()
	AJ.NotesNextDayButton.texture:SetTexture("interface/buttons/ui-spellbookicon-nextpage-up")
	AJ.NotesNextDayButton:SetScript('OnMouseUp', function() 
		AJ.HeaderDateText:SetText(AJ.GetDateFormatted())
		AJ.NotesDateDisplayed = date("*t", time(AJ.NotesDateDisplayed) + (24*60*60))
		AJ.HeaderDateText:SetText(AJ.GetDateFormatted(AJ.NotesDateDisplayed))
		AJ_NotesFrameOnShow()
	end)

	AJ.HeaderDateText = _G["AdventureJournal_NotesFrame"]:CreateFontString(nil, "OVERLAY")
	AJ.HeaderDateText:SetPoint("TOP", 0, -47)
	AJ.HeaderDateText:SetFont("Fonts\\FRIZQT__.TTF", 14)
	--AJ.HeaderDateText:SetTextColor()
	AJ.HeaderDateText:SetText(AJ.GetDateFormatted())

	local AddNoteInputBox = CreateFrame("EditBox", "AdventureJournal_AddNoteInputBox", AdventureJournal_NotesFrame, "InputBoxTemplate")
	AddNoteInputBox:SetFontObject(ChatFontSmall)
	AddNoteInputBox:SetPoint("TOPLEFT", 90, -63)
	AddNoteInputBox:SetSize(250, 24)
	AddNoteInputBox:SetText("New note")
	AddNoteInputBox:SetFrameStrata("DIALOG")
	AddNoteInputBox:SetAutoFocus(false)

	local AddNoteButton = CreateFrame("BUTTON", "AdventureJournal_AddNoteButton", AdventureJournal_NotesFrame, "UIPanelButtonTemplate")
	AddNoteButton:SetText("Add Note")
	AddNoteButton:SetPoint("TOPLEFT", 340, -63)
	AddNoteButton:SetSize(80, 22)
	AddNoteButton:SetScript('OnClick', function()
		if string.len(AddNoteInputBox:GetText()) > 0 then
			if AJ_GlobalVariables.Notes[UnitGUID('player')] == nil then
				AJ_GlobalVariables.Notes[UnitGUID('player')] = {}
			end
			if AJ_GlobalVariables ~= nil and AJ_GlobalVariables.Notes[UnitGUID('player')] ~= nil then
				AJ.AddNote('note', AddNoteInputBox:GetText(), nil)
				AJ.Print('added new note')
				AddNoteInputBox:SetText('')


				AJ_NotesFrameOnShow() -- re using this until i re write a proper notes listview refresh func

				--[==[
				local notesSorted = {}
				local today = date("*t")
				local c = 0

				for k, note in pairs(AJ_GlobalVariables.Notes[UnitGUID('player')]) do			
					if note.Date.year == today.year and note.Date.month == today.month and note.Date.day == today.day then
						table.insert(notesSorted, note)
						c = c + 1
						--print(note.Note, note.Date.hour, note.Date.min)
					end
				end
	
				AJ.ClearNotesListView()
				if c > 0 then
					table.sort(notesSorted, function(a, b) return time(a.Date) < time(b.Date) end)
					NotesListViewFrameScrollBar:SetMinMaxValues(1, math.ceil(c / 10))

					local v = math.ceil(NotesListViewFrameScrollBar:GetValue())
					local i = 1

					for k, n in ipairs(notesSorted) do			
						if k < ((v * 10) + 1) and k > ((v - 1) * 10) then
							--if _G["NotesListViewItem"..i] then
								if n.Date ~= nil and n.note then
									_G["NotesListViewItem"..i]:Show()
									_G["NotesListViewItem"..i].NoteTime:SetText(tostring(date("%H:%M:%S", time(n.Date))..':'))
									_G["NotesListViewItem"..i].NoteText:SetText(tostring(AJ.NotesItemTitle[n.Type]..n.Note))
								end
								i = i + 1
							--end
						end
					end
				end

				]==]--

			end
		end
	end)
	

	local NotesListViewFrame = CreateFrame("SCROLLFRAME", "AdventureJournal_NotesFrameContent", AdventureJournal_NotesFrame)
	NotesListViewFrame:SetPoint("TOPLEFT", 26, -100)
	NotesListViewFrame:SetSize(400, 405)

	local NotesListViewFrameScrollBar = CreateFrame("Slider", 'NotesListViewFrameScrollBar', NotesListViewFrame, "UIPanelScrollBarTemplate")
	NotesListViewFrameScrollBar:SetPoint("TOPLEFT", NotesListViewFrame, "TOPRIGHT", -24,-12) 
	NotesListViewFrameScrollBar:SetPoint("BOTTOMLEFT", NotesListViewFrame, "BOTTOMRIGHT", -24, 20)
	NotesListViewFrameScrollBar:SetMinMaxValues(1, 10)
	NotesListViewFrameScrollBar:SetValueStep(1.0)
	NotesListViewFrameScrollBar.scrollStep = 1
	NotesListViewFrameScrollBar:SetValue(1)
	NotesListViewFrameScrollBar:SetWidth(16)
	NotesListViewFrameScrollBar:SetScript('OnValueChanged', function(self, value)

		local notesSorted = {}
		local today = date("*t")
		local c = 0
		if AJ_GlobalVariables.Notes[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Notes[UnitGUID('player')] = {}
		end
		if AJ_GlobalVariables ~= nil and AJ_GlobalVariables.Notes[UnitGUID('player')] ~= nil then
			for k, note in pairs(AJ_GlobalVariables.Notes[UnitGUID('player')]) do			
				if note.Note and note.Date.year == today.year and note.Date.month == today.month and note.Date.day == today.day then
					table.insert(notesSorted, note)
					c = c + 1
					--print(note.Note, note.Date.hour, note.Date.min)
				end
			end
		end		
		AJ.ClearNotesListView()
		if c > 0 then
			table.sort(notesSorted, function(a, b) return time(a.Date) < time(b.Date) end)
			NotesListViewFrameScrollBar:SetMinMaxValues(1, math.ceil(c / 10))

			local v = math.ceil(value)
			local i = 1

			for k, n in ipairs(notesSorted) do
				--if n.Note then
					if k < ((v * 10) + 1) and k > ((v - 1) * 10) then
						_G["NotesListViewItem"..i]:Show()
						_G["NotesListViewItem"..i].NoteTime:SetText(tostring(date("%H:%M:%S", time(n.Date))..':'))
						if n.Type == 'quest-completed' then
							for j, p in pairs(AJ_GlobalVariables.Notes[UnitGUID('player')]) do
								if p.QuestID == n.QuestID and p.Type == 'quest' then
									_G["NotesListViewItem"..i].NoteText:SetText(AJ.NotesItemTitle[n.Type]..p.Note)
								end
							end
						else
							_G["NotesListViewItem"..i].NoteText:SetText(tostring(AJ.NotesItemTitle[n.Type]..n.Note))
						end
						i = i + 1
					end
				--end
			end
		end
	end)


	for i = 1, 10 do
		
		local f = CreateFrame("FRAME", tostring("NotesListViewItem"..i), NotesListViewFrame)
		f:SetPoint("TOPLEFT", 0, (((i - 1) * 40) * -1) + 5)
		f:SetSize(380, 45)
		f:SetBackdrop({ bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
						--edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		f:SetBackdropColor(0, 0, 0, 0.05)

		f.NoteTime = f:CreateFontString(nil, "OVERLAY")
		f.NoteTime:SetPoint("TOPLEFT", 8, -4)
		f.NoteTime:SetSize(60, 38)
		f.NoteTime:SetFont("Fonts\\MORPHEUS.ttf", 14)
		f.NoteTime:SetTextColor(0,0,0,1)
		f.NoteTime:SetJustifyH('left')
		f.NoteTime:SetJustifyV('center')

		f.NoteText = f:CreateFontString(nil, "OVERLAY")--, "GameFontNormal_NoShadow")
		f.NoteText:SetPoint("TOPLEFT", 70, -4)
		f.NoteText:SetSize(300, 38)
		f.NoteText:SetFont("Fonts\\MORPHEUS.ttf", 14)
		f.NoteText:SetTextColor(0.13, 0.08, 0.03, 1)
		f.NoteText:SetJustifyH('left')
		f.NoteText:SetJustifyV('middle')
		--f.NoteText:SetText([[this is some sample text for the notes sectio of the addon and will be replaced by the notes table data]])

	end
end

function AJ_NotesFrameOnShow()

	local notesSorted = {}
	local today = date("*t")
	local c = 0
	
	if AJ_GlobalVariables ~= nil and AJ_GlobalVariables.Notes[UnitGUID('player')] ~= nil then
		for k, note in pairs(AJ_GlobalVariables.Notes[UnitGUID('player')]) do
			if note.Note and note.Date.year == AJ.NotesDateDisplayed.year and note.Date.month == AJ.NotesDateDisplayed.month and note.Date.day == AJ.NotesDateDisplayed.day then
				table.insert(notesSorted, note)
				c = c + 1
				--print(note.Note, note.Date.hour, note.Date.min)
			end
		end
	end
	AJ.ClearNotesListView()
	if c > 0 then
		table.sort(notesSorted, function(a, b) return time(a.Date) < time(b.Date) end)
		for k, n in ipairs(notesSorted) do
			--if n.Note then
				if _G["NotesListViewItem"..k] then
					_G["NotesListViewItem"..k]:Show()
					_G["NotesListViewItem"..k].NoteTime:SetText(tostring(date("%H:%M:%S", time(n.Date))..':'))
				
					if n.Type == 'quest-completed' then
						for j, p in pairs(AJ_GlobalVariables.Notes[UnitGUID('player')]) do
							if p.QuestID == n.QuestID and p.Type == 'quest' then
								_G["NotesListViewItem"..k].NoteText:SetText(AJ.NotesItemTitle[n.Type]..p.Note)
							end
						end
					else
						_G["NotesListViewItem"..k].NoteText:SetText(tostring(AJ.NotesItemTitle[n.Type]..n.Note))
					end
				end
			--end
		end
	end
end

function AJ.DrawLootPage()

	AJ.SearchInputBox = CreateFrame("EditBox", "AdventureJournal_LootFrameInputBox", AdventureJournal_LootFrame, "InputBoxTemplate")
	AJ.SearchInputBox:SetFontObject(ChatFontSmall)
	AJ.SearchInputBox:SetPoint("TOPLEFT", 90, -62)
	AJ.SearchInputBox:SetSize(250, 24)
	AJ.SearchInputBox:SetText("Search items")
	AJ.SearchInputBox:SetFrameStrata("DIALOG")
	AJ.SearchInputBox:SetAutoFocus(false)
	AJ.SearchInputBox:SetScript("OnTextChanged", function() AJ.RefreshLootListView() end)

	AJ.SearchResultText = AdventureJournal_LootFrame:CreateFontString('AJ_SearchResultsText', "OVERLAY", "GameFontNormal")
	AJ.SearchResultText:SetPoint("TOPLEFT", 100, -48)
	AJ.SearchResultText:SetTextColor(1,1,1,1)
	AJ.SearchResultText:SetFont("Fonts\\FRIZQT__.TTF", 12)

	local SearchButton = CreateFrame("BUTTON", "AdventureJournal_LootSearchButton", AdventureJournal_LootFrame, "UIPanelButtonTemplate")
	SearchButton:SetText("Reset")
	SearchButton:SetPoint("TOPLEFT", 340, -62)
	SearchButton:SetSize(80, 22)
	SearchButton:SetScript("OnClick", function(self)
		--AJ.RefreshLootListView()
		AJ.SearchInputBox:SetText("")
	end)
	
	local LootListViewFrame = CreateFrame("SCROLLFRAME", "AdventureJournal_LootFrameContent", AdventureJournal_LootFrame)
	LootListViewFrame:SetPoint("TOPLEFT", 26, -100)
	LootListViewFrame:SetSize(400, 405)
	LootListViewFrame:SetBackdropColor(0, 0, 0, 1)

	local LootListViewFrameScrollBar = CreateFrame("Slider", 'LootListViewFrameScrollBar', LootListViewFrame, "UIPanelScrollBarTemplate")
	LootListViewFrameScrollBar:SetPoint("TOPLEFT", LootListViewFrame, "TOPRIGHT", -24,-12) 
	LootListViewFrameScrollBar:SetPoint("BOTTOMLEFT", LootListViewFrame, "BOTTOMRIGHT", -24, 20)
	LootListViewFrameScrollBar:SetMinMaxValues(1, 10)
	LootListViewFrameScrollBar:SetValueStep(1.0)
	LootListViewFrameScrollBar.scrollStep = 1
	LootListViewFrameScrollBar:SetValue(1)
	LootListViewFrameScrollBar:SetWidth(16)
	LootListViewFrameScrollBar:SetScript('OnValueChanged', function(self, value)
		local v = math.ceil(value)
		local i = 1
		AJ.CLearLootListView()
		for k, l in ipairs(AJ.LootSearchTable) do			
			if k < ((v * 10) + 1) and k > ((v - 1) * 10) then
				_G["LootListViewItem"..i]:Show()
				_G["LootListViewItem"..i].ItemName:SetText(tostring('|cff0070DEItem: |r'..l.Link))
				_G["LootListViewItem"..i].ItemZone:SetText(tostring('|cffABD473Zone: |r'..l.MapZoneName))
				_G["LootListViewItem"..i].ItemSource:SetText(tostring('|cffFF7D0ASource: |r'..l.SourceName))
				_G["LootListViewItem"..i].lootTime = time(l.Date)
				_G["LootListViewItem"..i].itemName = l.Name
				i = i + 1
			end
		end
	end)

	AJ.LootListViewItems = {}
	for i = 1, 10 do
		
		local f = CreateFrame("FRAME", tostring("LootListViewItem"..i), LootListViewFrame)
		f:SetPoint("TOPLEFT", 0, (((i - 1) * 40) * -1) + 5)
		f:SetSize(380, 47)
		f:SetBackdrop({ bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
						--edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		f:SetBackdropColor(0, 0, 0, 0.6)
		f:Hide()
		f.lootTime = nil
		f.itemName = nil
		f:SetScript('OnMouseUp', function()
			local removeKey = nil
			if IsAltKeyDown() and GetMouseButtonClicked() == 'RightButton' then 
				for k, loot in pairs(AJ_GlobalVariables.Loot) do
					if time(loot.Date) == f.lootTime and loot.Name == f.itemName then
						--print('removing', loot.Name, loot.MapZoneName)
						removeKey = k
					end
				end
			end
			if removeKey then
				
			end
		end)
		
		f.ItemName = f:CreateFontString(nil, "OVERLAY", "GameFontNormal_NoShadow")
		f.ItemName:SetPoint("TOPLEFT", 8, -6)
		f.ItemName:SetFont("Fonts\\FRIZQT__.TTF", 12)
		f.ItemName:SetTextColor(1,1,1,1)

		f.ItemZone = f:CreateFontString(nil, "OVERLAY", "GameFontNormal_NoShadow")
		f.ItemZone:SetPoint("TOPLEFT", 12, -20)
		f.ItemZone:SetFont("Fonts\\FRIZQT__.TTF", 10)
		f.ItemZone:SetTextColor(1,1,1,1)

		f.ItemSource = f:CreateFontString(nil, "OVERLAY", "GameFontNormal_NoShadow")
		f.ItemSource:SetPoint("TOPLEFT", 12, -30)
		f.ItemSource:SetFont("Fonts\\FRIZQT__.TTF", 10)
		f.ItemSource:SetTextColor(1,1,1,1)

		AJ.LootListViewItems[i] = f

	end
end

function AJ.RefreshLootListView()
	if AJ.SearchInputBox:GetText() then
		AJ.LootSearchTable = {}
		AJ.CLearLootListView()
		local c = 0
		for k, loot in pairs(AJ_GlobalVariables.Loot) do
			if string.find(string.lower(loot.Name), string.lower(AJ.SearchInputBox:GetText())) then
				table.insert(AJ.LootSearchTable, loot)
				c = c + 1
			end
		end
		if c > 0 then
			table.sort(AJ.LootSearchTable, function(a, b) return a.Name < b.Name end)
			LootListViewFrameScrollBar:SetMinMaxValues(1, math.ceil(c / 10))
			for k, l in pairs(AJ.LootSearchTable) do
				if _G["LootListViewItem"..k] then
				--print(k, c)
					if l.Link then _G["LootListViewItem"..k].ItemName:SetText(tostring('|cff0070DEItem: |r'..l.Link)) end
					if l.MapZoneName then _G["LootListViewItem"..k].ItemZone:SetText(tostring('|cffABD473Zone: |r'..l.MapZoneName)) end
					if l.SourceName then _G["LootListViewItem"..k].ItemSource:SetText(tostring('|cffFF7D0ASource: |r'..l.SourceName)) end
					if l.Name then _G["LootListViewItem"..k].itemName = l.Name end
					if l.Date then _G["LootListViewItem"..k].lootTime = time(l.Date) end
					_G["LootListViewItem"..k]:Show()
				end
			end
		end
		AJ.SearchResultText:SetText('Found '..c..' items')
	end
	--LootListViewFrameScrollBar:SetValue(1)
end

function AJ.CreateListView(parentFrame, globalName, width, height, anchor, offsetX, offsetY)
	local f = CreateFrame("SCROLLFRAME", globalName, parent)
	f:SetPoint(anchor, offsetX, offsetY)
	f:SetSize(width, height)
	f:SetBackdropColor(0, 0, 0, 1)

	f.scrollFrame = CreateFrame("Slider", globalName..'_ScrollFrame', f, "UIPanelScrollBarTemplate")
	f.scrollFrame:SetPoint("TOPLEFT", f, "TOPRIGHT", -24,-12) 
	f.scrollFrame:SetPoint("BOTTOMLEFT", f, "BOTTOMRIGHT", -24, 20)
	f.scrollFrame:SetMinMaxValues(1, 10)
	f.scrollFrame:SetValueStep(1.0)
	f.scrollFrame.scrollStep = 1
	f.scrollFrame:SetValue(1)
	f.scrollFrame:SetWidth(16)

end


function AJ.DrawBagsFrame()
	
	local SellJunkButton = CreateFrame("BUTTON", "AdventureJournal_SellJunkButton", AdventureJournal_BagsFrame, "UIPanelButtonTemplate")
	SellJunkButton:SetText("Sell Junk")
	SellJunkButton:SetPoint("TOPLEFT", 340, -62)
	SellJunkButton:SetSize(80, 22)
	SellJunkButton:SetScript('OnClick', function()
		AJ.SellJunk()
	end)

--[==[
	local ConsumablesHeader = AdventureJournal_BagsFrame:CreateFontString("AJ_ConsumablesHeader", "OVERLAY", "GameFontNormal_NoShadow")
	ConsumablesHeader:SetText("Consumables")
	ConsumablesHeader:SetPoint("TOPLEFT", 50, -100)
	ConsumablesHeader:SetFont("Fonts\\MORPHEUS.ttf", 16)
	ConsumablesHeader:SetTextColor(0.13, 0.08, 0.03, 1)
]==]--

	AJ.BagsConsumablesListView = CreateFrame("SCROLLFRAME", "AJ_ConsumablesListViewFrame", AdventureJournal_BagsFrame)
	AJ.BagsConsumablesListView:SetPoint("TOPLEFT", 26, -100)
	AJ.BagsConsumablesListView:SetSize(400, 400)
	AJ.BagsConsumablesListView.texture = AJ.BagsConsumablesListView:CreateTexture(nil, "ARTWORK")
	AJ.BagsConsumablesListView.texture:SetAllPoints(AJ.BagsConsumablesListView)
	AJ.BagsConsumablesListView.texture:SetTexture(0,0,0,1)

	AJ.BagsConsumablesListView.scrollFrame = CreateFrame("Slider", "AJ_ConsumablesListViewFrame_ScrollFrame", AJ.BagsConsumablesListView, "UIPanelScrollBarTemplate")
	AJ.BagsConsumablesListView.scrollFrame:SetPoint("TOPLEFT", AJ.BagsConsumablesListView, "TOPRIGHT", -24,-12) 
	AJ.BagsConsumablesListView.scrollFrame:SetPoint("BOTTOMLEFT", AJ.BagsConsumablesListView, "BOTTOMRIGHT", -24, 20)
	AJ.BagsConsumablesListView.scrollFrame:SetMinMaxValues(1, 20)
	AJ.BagsConsumablesListView.scrollFrame:SetValueStep(1.0)
	AJ.BagsConsumablesListView.scrollFrame.scrollStep = 1
	AJ.BagsConsumablesListView.scrollFrame:SetValue(1)
	AJ.BagsConsumablesListView.scrollFrame:SetWidth(16)
	AJ.BagsConsumablesListView.scrollFrame:SetScript('OnValueChanged', function(self, value)


		local v = math.ceil(value)
		local i = 1
		AJ.CLearBagListView()
		for k, l in ipairs(AJ.BagsItemList) do			
			if k < ((v * 20) + 1) and k > ((v - 1) * 20) then
				AJ.BagFrameListViewItems[i]:Show()
				AJ.BagFrameListViewItems[i].ItemName:SetText(l.Link)
				AJ.BagFrameListViewItems[i].ItemType:SetText(select(6, GetItemInfo(l.Link)))
				if l.TypeID == 0 or l.TypeID == 7 then
					AJ.BagFrameListViewItems[i].ItemType:SetText(tostring(AJ.BagsItemTypeColours[l.TypeID]..select(6, GetItemInfo(l.Link))))
				end
				AJ.BagFrameListViewItems[i].ItemCount:SetText(l.SlotCount)
				i = i + 1
			end
		end

	end)


	AJ.BagFrameListViewItems = {}
	for i = 1, 20 do
		
		local f = CreateFrame("FRAME", tostring("BagsListViewItem"..i), AJ.BagsConsumablesListView)
		f:SetPoint("TOPLEFT", 0, (((i - 1) * 20) * -1) + 5)
		f:SetSize(380, 26)
		f:SetBackdrop({ bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
						--edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		f:SetBackdropColor(0, 0, 0, 0.6)
		--f:Hide()
	
		f.ItemName = f:CreateFontString(nil, "OVERLAY", "GameFontNormal_NoShadow")
		f.ItemName:SetPoint("LEFT", 8, 0)
		f.ItemName:SetFont("Fonts\\FRIZQT__.TTF", 12)
		f.ItemName:SetTextColor(1,1,1,1)
		f.ItemName:SetText('test item name')

		f.ItemType = f:CreateFontString(nil, "OVERLAY", "GameFontNormal_NoShadow")
		f.ItemType:SetPoint("LEFT", 230, 0)
		f.ItemType:SetFont("Fonts\\FRIZQT__.TTF", 12)
		f.ItemType:SetTextColor(1,1,1,1)
		f.ItemType:SetText('test type')

		f.ItemCount = f:CreateFontString(nil, "OVERLAY", "GameFontNormal_NoShadow")
		f.ItemCount:SetPoint("LEFT", 340, 0)
		f.ItemCount:SetFont("Fonts\\FRIZQT__.TTF", 12)
		f.ItemCount:SetTextColor(1,1,1,1)
		f.ItemCount:SetText('20')

		AJ.BagFrameListViewItems[i] = f

	end
end

function AJ.RefreshBagsListView()

end


AJ.BagsItemTypeColours = { [7] = '|cff40C7EB', [0] = '|cffABD473' }
function AJ_BagsFrameOnShow()
	--get bag data
	AJ.CLearBagListView()
	AJ.BagsItemList = {}
	local c = 0
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag,slot)
			if link then
				local rarity = select(3, GetItemInfo(link))
				local vendorPrice = select(11, GetItemInfo(link))
				local typeID = select(12, GetItemInfo(link))
				local subTypeID = select(13, GetItemInfo(link))
				local icon = select(10, GetItemInfo(link))
				local count = select(2, GetContainerItemInfo(bag, slot))

				table.insert(AJ.BagsItemList, { BagId = bag, SlotID = slot, SlotCount = count, Link = link, Rarity = rarity, VendorPrice = vendorPrice, TypeID = typeID, SubTypeID = subTypeID, Icon = icon })
				c = c + 1
			end
		end
	end

	table.sort(AJ.BagsItemList, function(a,b) return a.TypeID < b.TypeID end)

	for k, i in ipairs(AJ.BagsItemList) do
		--print(i.Link, i.TypeID)

		if AJ.BagFrameListViewItems[k] then
			AJ.BagFrameListViewItems[k].ItemName:SetText(i.Link)
			AJ.BagFrameListViewItems[k].ItemType:SetText(select(6, GetItemInfo(i.Link)))
			if i.TypeID == 0 or i.TypeID == 7 then
				AJ.BagFrameListViewItems[k].ItemType:SetText(tostring(AJ.BagsItemTypeColours[i.TypeID]..select(6, GetItemInfo(i.Link))))
			end
			AJ.BagFrameListViewItems[k].ItemCount:SetText(i.SlotCount)
			AJ.BagFrameListViewItems[k]:Show()
		end
	end

	AJ.BagsConsumablesListView.scrollFrame:SetValue(1)
	if c > 20 then
		AJ.BagsConsumablesListView.scrollFrame:SetMinMaxValues(1, c/20)
	end

end

function AJ.ScanLootWindow()
	--get map data
	local mapID = C_Map.GetBestMapForUnit('player')
	local currentMapPosition = C_Map.GetPlayerMapPosition(mapID, 'player')
	local currentMapName = C_Map.GetMapInfo(mapID).name
	--scan loot window and get item data
	for i = 1, GetNumLootItems() do
		if (LootSlotHasItem(i)) and GetLootSlotType(i) == 1 then
			
			local newNode = true

			local n = 'Unkown'
			local l = GetLootSlotLink(i)
			local icon = nil

			 if AJ.LastGameObjectTarget == nil then
				icon = select(10, GetItemInfo(l))
				--print('first item'..icon)
			 elseif select(1, GetLootSourceInfo(i)) == AJ.LastGameObjectTarget then
				icon = AJ.LastGameObjectTargetIcon
				--print('other items'..icon)
			 end

			local _name = select(1, GetItemInfo(l))
			local rarity = select(3, GetItemInfo(l)) -- add check here if rarity > 1 to exclude junk
			if rarity > 0 then
				--local icon = select(10, GetItemInfo(l))
				local price = select(11, GetItemInfo(l))
				local typeID = select(12, GetItemInfo(l))
				local subTypeID = select(13, GetItemInfo(l))
				local sourceGUID, _ = GetLootSourceInfo(i)

				if string.find(sourceGUID, 'Creature') then -- is this locale specific ?
					--print('creature')
					if AJ.RecentCombatTargets ~= nil then
						for k, t in pairs(AJ.RecentCombatTargets) do
							if t.GUID == sourceGUID then
								n = t.Name
							end
						end
					end
				elseif string.find(sourceGUID, 'GameObject') then
					n = AJ.LastSpellTarget
					if AJ.LastSpellTarget ~= nil and string.find(string.lower(AJ.LastSpellTarget), string.lower('chest')) then -- set chest icon
						icon = 132594
					end

					if AJ.FishingCast == true then
						n = 'Fishing'
					end
					AJ.FishingCast = false

				end



				--if newNode == true then
				if 1 == 1 then
					if string.find(sourceGUID, 'GameObject') and n ~= nil then
						--AJ.Print('adding '..n..' to journal')
						if currentMapPosition then
							table.insert(AJ_GlobalVariables.GameObjects, { Name = _name, Link = l, IconID = icon, Price = price, Rarity = rarity, ItemTypeID = typeID, ItemSubTypeID = subTypeID, SourceGUID = sourceGUID, SourceName = n, MapID = mapID, MapZoneName = currentMapName, MapZonePosX = currentMapPosition.x, MapZonePosY = currentMapPosition.y, Date = date("*t") } )
						else
							table.insert(AJ_GlobalVariables.GameObjects, { Name = _name, Link = l, IconID = icon, Price = price, Rarity = rarity, ItemTypeID = typeID, ItemSubTypeID = subTypeID, SourceGUID = sourceGUID, SourceName = n, MapID = mapID, MapZoneName = GetMinimapZoneText(), MapZonePosX = 'Unknown', MapZonePosY = 'Unkown', Date = date("*t") } )
						end
						AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[n] = true
						AJ.WorldMapUpdate = true
					end
					if currentMapPosition then
						table.insert(AJ_GlobalVariables.Loot, { Name = _name, Link = l, IconID = icon, Price = price, Rarity = rarity, ItemTypeID = typeID, ItemSubTypeID = subTypeID, SourceGUID = sourceGUID, SourceName = n, MapID = mapID, MapZoneName = currentMapName, MapZonePosX = currentMapPosition.x, MapZonePosY = currentMapPosition.y, Date = date("*t") } )
					else
						table.insert(AJ_GlobalVariables.Loot, { Name = _name, Link = l, IconID = icon, Price = price, Rarity = rarity, ItemTypeID = typeID, ItemSubTypeID = subTypeID, SourceGUID = sourceGUID, SourceName = n, MapID = mapID, MapZoneName = GetMinimapZoneText(), MapZonePosX = 'Unknown', MapZonePosY = 'Unkown', Date = date("*t") } )
					end
				end

				AJ.LastGameObjectTarget = sourceGUID
				AJ.LastGameObjectTargetIcon = icon
			end
		end
	end
	AJ.LastGameObjectTarget = nil
	AJ.LastGameObjectTargetIcon = nil

	
end

function AJ.DrawOptionsPage()
	
	local AdventureJournal_OptionsPageHeader = AdventureJournal_OptionsFrame:CreateFontString("AJ_OptionsPageHeader", "OVERLAY", "GameFontNormal_NoShadow")
	AdventureJournal_OptionsPageHeader:SetPoint("TOPLEFT", 38, -100)
	AdventureJournal_OptionsPageHeader:SetText("Map Options")
	AdventureJournal_OptionsPageHeader:SetFont("Fonts\\FRIZQT__.TTF", 14)
	AdventureJournal_OptionsPageHeader:SetTextColor(0.13, 0.08, 0.03, 1)

	AJ.ShowIconsCheckBox = CreateFrame("CheckButton", 'AJ_ShowIconsCheckBox', AdventureJournal_OptionsFrame, "ChatConfigCheckButtonTemplate")
	AJ.ShowIconsCheckBox:SetPoint('TOPLEFT', 40, -120)
	AJ_ShowIconsCheckBoxText:SetText('|cffffffffMinimap Icons|r')
	AJ_ShowIconsCheckBoxText:SetSize(150, 30)
	AJ.ShowIconsCheckBox:SetScript('OnClick', function(self)
		if AJ_GlobalVariables.Settings[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Settings[UnitGUID('player')] = {}
			AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayMinimapIcons = self:GetChecked()
		else
			AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayMinimapIcons = self:GetChecked()
		end
	end)
	AJ.ShowIconsCheckBox.tooltip = 'Display icons on the minimap.\n\nDecreases performance!'

	AJ.ShowIconsWorldMapCheckBox = CreateFrame("CheckButton", 'AJ_ShowIconsWorldMapCheckBox', AdventureJournal_OptionsFrame, "ChatConfigCheckButtonTemplate")
	AJ.ShowIconsWorldMapCheckBox:SetPoint('TOPLEFT', 40, -145)
	AJ_ShowIconsWorldMapCheckBoxText:SetText('|cffffffffWorld Map Icons|r')
	AJ_ShowIconsWorldMapCheckBoxText:SetSize(150, 30)
	AJ.ShowIconsWorldMapCheckBox:SetScript('OnClick', function(self) 
		if AJ_GlobalVariables.Settings[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Settings[UnitGUID('player')] = {}
			AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayWorldMapIcons = self:GetChecked()
		else
			AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayWorldMapIcons = self:GetChecked()
		end
	end)
	AJ.ShowIconsWorldMapCheckBox.tooltip = 'Display icons on the World Map.'


	AJ.MapObjectsDropDownButton = CreateFrame("BUTTON", "AJ_MapObjectsDropDownButton", AdventureJournal_OptionsFrame, "UIPanelButtonTemplate")
	AJ.MapObjectsDropDownButton:SetPoint("TOPLEFT", 40, -175)
	AJ.MapObjectsDropDownButton:SetText('Map Objects')
	AJ.MapObjectsDropDownButton:SetSize(170, 22)
	AJ.MapObjectsDropDownButton:SetScript('OnClick', function() 
		if AJ.MapObjectsDropDownContainer:IsVisible() then 
			AJ.MapObjectsDropDownContainer:Hide() 
		else 
			AJ.MapObjectsDropDownContainer:Show()
			if AJ_GlobalVariables.GameObjects ~= nil then
				local objs = {}
				local i = 1
				for k, g in pairs(AJ_GlobalVariables.GameObjects) do
					if objs == nil then
						if _G['AJ_MapObjectsCheckBox'..i] then
							table.insert(objs, g.SourceName)
							_G['AJ_MapObjectsCheckBox'..i..'Text']:SetText(g.SourceName)
							_G['AJ_MapObjectsCheckBox'..i]:Show()
							_G['AJ_MapObjectsCheckBox'..i].nodeName = g.SourceName
							_G['AJ_MapObjectsCheckBox'..i]:SetChecked(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[g.SourceName])
							i = i + 1
						end
					else
						local add = true
						for k, a in pairs(objs) do
						--print(a)
							if a == g.SourceName then
								add = false
							end
						end
						if add == true then
							if _G['AJ_MapObjectsCheckBox'..i] then
								table.insert(objs, g.SourceName)
								_G['AJ_MapObjectsCheckBox'..i..'Text']:SetText(g.SourceName)
								_G['AJ_MapObjectsCheckBox'..i]:Show()
								_G['AJ_MapObjectsCheckBox'..i].nodeName = g.SourceName
								_G['AJ_MapObjectsCheckBox'..i]:SetChecked(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[g.SourceName])
								i = i + 1
							end
						end
					end
				end
			end
		end 
	end)
	AJ.MapObjectsDropDownButton:Hide()


	AJ.MapObjectsDropDownContainer = CreateFrame("SCROLLFRAME", "AJ_MapObjectsDropDownContainer", AdventureJournal_OptionsFrame, "TooltipBorderedFrameTemplate")
	AJ.MapObjectsDropDownContainer:SetPoint("TOPLEFT", -140, -50)
	AJ.MapObjectsDropDownContainer:SetSize(180, 450)
	AJ.MapObjectsDropDownContainer:Hide()

	AJ.MapObjectsContainerSlider = CreateFrame("Slider", 'LootListViewFrameScrollBar', AJ.MapObjectsDropDownContainer, "UIPanelScrollBarTemplate")
	AJ.MapObjectsContainerSlider:SetPoint("TOPLEFT", AJ.MapObjectsDropDownContainer, "TOPRIGHT", -22,-22) 
	AJ.MapObjectsContainerSlider:SetPoint("BOTTOMLEFT", AJ.MapObjectsDropDownContainer, "BOTTOMRIGHT", -22, 22)
	AJ.MapObjectsContainerSlider:SetMinMaxValues(1, 10)
	AJ.MapObjectsContainerSlider:SetValueStep(1.0)
	AJ.MapObjectsContainerSlider.scrollStep = 1
	AJ.MapObjectsContainerSlider:SetValue(1)
	AJ.MapObjectsContainerSlider:SetWidth(16)
	AJ.MapObjectsContainerSlider:SetScript('OnValueChanged', function(self, value)
		local v = math.ceil(value)
		local i = 1
	end)

	--create check box
	AJ.MapObjectCheckBoxes = {}
	for i = 1, 20 do
	
		local cb = CreateFrame("CheckButton", 'AJ_MapObjectsCheckBox'..i, AJ.MapObjectsDropDownContainer, "ChatConfigCheckButtonTemplate")
		cb:SetPoint('TOPLEFT', 4, (((i - 1) * 22) * -1) - 4)
		cb:Hide()
		cb:SetScript('OnClick', function(self) 
			AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[self.nodeName] = not AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[self.nodeName] 
			AJ.WorldMapUpdate = true AJ.UpdateWorldMapPins()
			print(self.nodeName,AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[self.nodeName])
		end)
		--_G['AJ_MapObjectsCheckBox'..i..'Text']:SetText('|cffffffffgame object|r')

		AJ.MapObjectCheckBoxes[i] = cb
	end



--[==[
	AJ.MinimapDisplayObjectDropdown = CreateFrame("FRAME", "AJ_MinimapDisplayObjectDropdown", AdventureJournal_OptionsFrame, "UIDropDownMenuTemplate")
	AJ.MinimapDisplayObjectDropdown:SetPoint("TOPLEFT", 26, -175)
	AJ.MinimapDisplayObjectDropdown.displayMode = "MENU"
	UIDropDownMenu_SetWidth(AJ.MinimapDisplayObjectDropdown, 140)
	UIDropDownMenu_SetText(AJ.MinimapDisplayObjectDropdown, 'Map Objects')
]==]--

	AJ.MinimapIconSizeSlider = CreateFrame("Slider", "AJ_MinimapIconSizeSlideBar", AdventureJournal_OptionsFrame, "OptionsSliderTemplate")
	AJ.MinimapIconSizeSlider:SetThumbTexture("Interface/Buttons/UI-SliderBar-Button-Horizontal")
	AJ.MinimapIconSizeSlider:SetSize(160, 20)
	AJ.MinimapIconSizeSlider:SetOrientation('HORIZONTAL')
	AJ.MinimapIconSizeSlider:SetPoint('TOPLEFT', 230, -125)
	AJ.MinimapIconSizeSlider:SetValue(8)
	AJ.MinimapIconSizeSlider:SetMinMaxValues(4, 20)
	AJ.MinimapIconSizeSlider:SetValueStep(1)
	--get value when changed
	AJ.MinimapIconSizeSlider:SetScript('OnValueChanged', function(self) 
		_G[AJ.MinimapIconSizeSlider:GetName() .. 'Text']:SetText(tostring('Icon Size: '..string.format('%.0f', tostring(self:GetValue()))))
		if AJ_GlobalVariables.Settings[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Settings[UnitGUID('player')] = {}
			AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize = tonumber(self:GetValue())
		else
			AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize = tonumber(self:GetValue())
		end
		AJ.WorldMapUpdate = true AJ.UpdateWorldMapPins()
	end)
	AJ.MinimapIconSizeSlider.tooltipText = 'Adjust the icon size for World Map and Minimap' --Creates a tooltip on mouseover.
	getglobal(AJ.MinimapIconSizeSlider:GetName()..'Low'):SetText('4')
	getglobal(AJ.MinimapIconSizeSlider:GetName()..'High'):SetText('20')
	getglobal(AJ.MinimapIconSizeSlider:GetName()..'Text'):SetText('Icon Size')


	AJ.HideMinimapPinDistanceSlider = CreateFrame("Slider", "AJ_HideMinimapPinDistanceSlider", AdventureJournal_OptionsFrame, "OptionsSliderTemplate")
	AJ.HideMinimapPinDistanceSlider:SetThumbTexture("Interface/Buttons/UI-SliderBar-Button-Horizontal")
	AJ.HideMinimapPinDistanceSlider:SetSize(160, 20)
	AJ.HideMinimapPinDistanceSlider:SetOrientation('HORIZONTAL')
	AJ.HideMinimapPinDistanceSlider:SetPoint('TOPLEFT', 230, -175)
	AJ.HideMinimapPinDistanceSlider:SetValue(8)
	AJ.HideMinimapPinDistanceSlider:SetMinMaxValues(0.1, 4.5)
	AJ.HideMinimapPinDistanceSlider:SetValueStep(0.1)
	--get value when changed
	AJ.HideMinimapPinDistanceSlider:SetScript('OnValueChanged', function(self) 
		_G[AJ.HideMinimapPinDistanceSlider:GetName() .. 'Text']:SetText(tostring('View Distance: '..string.format('%.1f', tostring(self:GetValue()))))
		if AJ_GlobalVariables.Settings[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Settings[UnitGUID('player')] = {}
			AJ_GlobalVariables.Settings[UnitGUID('player')].HideMinimapPinDistance = tonumber(self:GetValue())
		else
			AJ_GlobalVariables.Settings[UnitGUID('player')].HideMinimapPinDistance = tonumber(self:GetValue())
		end
	end)
	AJ.HideMinimapPinDistanceSlider.tooltipText = 'Minimap View Distance, adjusts the distance at which icons disappear' --Creates a tooltip on mouseover.
	getglobal(AJ.HideMinimapPinDistanceSlider:GetName()..'Low'):SetText('4')
	getglobal(AJ.HideMinimapPinDistanceSlider:GetName()..'High'):SetText('20')
	getglobal(AJ.HideMinimapPinDistanceSlider:GetName()..'Text'):SetText('View Distance')

	AJ.HideMinimapPinDistanceSlider:Hide()

end

function AJ.MinimapDisplayObjectDropdown_Init()
	UIDropDownMenu_Initialize(AJ.MinimapDisplayObjectDropdown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
		local objs = {}
		if (level or 1) == 1 then
			for k, loot in ipairs(AJ_GlobalVariables.Loot) do
				if string.find(loot.SourceGUID, 'GameObject') and (loot.ItemTypeID == 7 or loot.ItemTypeID == 4) then -- and loot.MapZoneName == GetMinimapZoneText() then
					if objs == nil then
						table.insert(objs, loot.SourceName)
						info.text = loot.SourceName
						info.arg1 = loot.SourceName
						info.arg2 = nil						
						info.func = function() AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] = not AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName]  end
						info.checked = AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName]
						info.isNotRadio = true
						--info.hasArrow = true
						--info.menuList = class.MenuList
						UIDropDownMenu_AddButton(info)
					else
						local add = true
						for k, obj in pairs(objs) do
							if obj == loot.SourceName then
								add = false
							end
						end
						if add == true then
							table.insert(objs, loot.SourceName)
							info.text = loot.SourceName
							info.arg1 = loot.SourceName
							info.arg2 = nil
							info.func = function() AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName] = not AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName]  end
							info.checked = AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[loot.SourceName]
							info.isNotRadio = true
							--info.hasArrow = true
							--info.menuList = class.MenuList
							UIDropDownMenu_AddButton(info)
						end
					end
				end
			end
			--[==[
		else
			info.func = self.SetValue
			for k, spec in ipairs(menuList) do
				info.text = spec.Spec
				info.arg1 = spec.Abbrev
				info.arg2 = spec.Spec
				UIDropDownMenu_AddButton(info, level)
			end
			]==]--
		end
	end)
end

function AJ_MinimapDisplayObjectDropdown_OnClick(info, arg1, checked)
	print(text, arg1, arg2, checked)
	if checked == true then
		AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[arg1] = checked
	else
		AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[arg1] = checked
	end
	print(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapDisplayObjects[arg1])
end


function AJ_OnLoad(self)
	AJ.Print('loaded!')
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("LOOT_OPENED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("COMBAT_LOG_EVENT")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("QUEST_LOOT_RECEIVED")
	self:RegisterEvent("QUEST_ACCEPTED")
	self:RegisterEvent("UI_INFO_MESSAGE")
	self:RegisterEvent("QUEST_TURNED_IN")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("QUEST_LOG_UPDATE")

	self:SetMovable(true)
	self:EnableMouse(true)
	self:RegisterForDrag("LeftButton")
	self:SetScript("OnDragStart", self.StartMoving)
	self:SetScript("OnDragStop", self.StopMovingOrSizing)

	Minimap:HookScript('OnMouseUp', function(self, button) 
		if button == "RightButton" and IsAltKeyDown() then 
			if AdventureJournal:IsVisible() then 
				AdventureJournal:Hide() 
			else 
				AdventureJournal_BagsFrame:Hide()
				AdventureJournal_LootFrame:Hide()
				AdventureJournal_OptionsFrame:Hide()
				AdventureJournal:Show() 
			end 
		end
	end)

	local AdventureJournal_CloseButton = CreateFrame("BUTTON", "AdventureJournal_CloseButton", AdventureJournal, "UIPanelButtonTemplate")
	AdventureJournal_CloseButton:SetPoint("TOPRIGHT", -48, -18)
	AdventureJournal_CloseButton:SetText('|cffffffffX|r')
	AdventureJournal_CloseButton:SetSize(28, 22)
	AdventureJournal_CloseButton:SetScript('OnClick', function() AdventureJournal:Hide() end)
	
	SetPortraitTexture(_G[self:GetName().."_PortraitTexture"], 'player')

	--self:Hide()

	AJ.DrawLootPage()
	AJ.DrawNotesPage()
	AJ.DrawBagsFrame()
	AJ.DrawOptionsPage()
	
	AdventureJournal_BagsFrame:Hide()
    AdventureJournal_LootFrame:Hide()
    AdventureJournal_OptionsFrame:Hide()
    AdventureJournal_NotesFrame:Show()

	AJ.MinimapNodeTooltip = CreateFrame("FRAME", "AJ_MinimapNodeTooltip", Minimap)
	AJ.MinimapNodeTooltip:SetPoint("LEFT", -140, 0)
	AJ.MinimapNodeTooltip:SetSize(100, 35)
	AJ.MinimapNodeTooltip:SetBackdrop({ bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
						edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	AJ.MinimapNodeTooltip:SetBackdropColor(0, 0, 0, 0.8)
	AJ.MinimapNodeTooltip:Hide()

	AJ.MinimapNodeTooltip.NodeSourceText = AJ.MinimapNodeTooltip:CreateFontString("MinimapNodeTooltip_SourceText", "OVERLAY", "GameFontNormal")
	AJ.MinimapNodeTooltip.NodeSourceText:SetPoint("CENTER", 0, 0)
	--MinimapNodeTooltip.NodeSourceText:SetFont()

	local ticker = C_Timer.After(2, function() 

		if AJ_GlobalVariables.Settings[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Settings[UnitGUID('player')] = { MinimapIconSize = 8.0, HideMinimapPinDistance = 2.5, DisplayMinimapIcons = true, DisplayWorldMapIcons = false, GuildShare = false, MinimapDisplayObjects = {}, WorldMapDisplayObjects = {} }
		end

		if AJ_GlobalVariables.Notes[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Notes[UnitGUID('player')] = {}
		end

		AJ.MinimapIconSizeSlider:SetValue(AJ_GlobalVariables.Settings[UnitGUID('player')].MinimapIconSize)
		AJ.HideMinimapPinDistanceSlider:SetValue(AJ_GlobalVariables.Settings[UnitGUID('player')].HideMinimapPinDistance)
		AJ.ShowIconsCheckBox:SetChecked(AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayMinimapIcons)
		AJ.ShowIconsWorldMapCheckBox:SetChecked(AJ_GlobalVariables.Settings[UnitGUID('player')].DisplayWorldMapIcons)

		--AJ.MinimapDisplayObjectDropdown_Init()
		
		AJ_NotesFrameOnShow()

		AJ.VarsLoaded = true
		AJ.WorldMapUpdate = true

	end)

end

function AJ.OnUpdate()
	AJ.UpdateMiniMapPins()
	--AJ.UpdateMinimapPins()
	AJ.UpdateWorldMapPins()
end



function AJ_OnEvent(self, event, ...)

	if event == "ADDON_LOADED" and string.lower(select(1, ...)) == 'adventurejournal' then
		if AJ_GlobalVariables == nil then
			AJ_GlobalVariables = { AddonName = "AdventureJournal", Loot = {}, GameObjects = {}, Notes = {}, Settings = {} }
		end
	end

	if event == "QUEST_ACCEPTED" then
		--print('quest accepted')
		local questID = select(2, ...)
		local questName = GetQuestLogTitle(select(1, ...))

		if AJ_GlobalVariables.Notes[UnitGUID('player')] == nil then
			AJ_GlobalVariables.Notes[UnitGUID('player')] = {}
		end
		AJ.AddNote('quest', questName, questID)
	end

	if event == "QUEST_TURNED_IN" then
		local questID = select(1, ...)
		local l = GetQuestLink(select(1, ...))
		AJ.AddNote('quest-completed', l, questID)
	end

	if event == "UI_INFO_MESSAGE" then
		--print('ui info msg')
		if select(1, ...) == 372 then
			--print(select(2, ...))
			AJ.AddNote('discovered', select(2, ...), nil)
		end
	end

	if event == "UNIT_SPELLCAST_SENT" then
		AJ.LastSpellTarget = select(2, ...)
		--print(AJ.LastSpellTarget)
		if InCombatLockdown() == false then
			for k, s in pairs(AJ.FishingSpells) do
				if s == select(4, ...) then
					AJ.FishingCast = true
					--print('fishing')
				end
			end
		end
	end

	if event == "COMBAT_LOG_EVENT" then
		local npcName = select(9, CombatLogGetCurrentEventInfo())
		local npcGUID = select(8, CombatLogGetCurrentEventInfo())
		--this needs to be managed and kept small
		table.insert( AJ.RecentCombatTargets, { GUID = npcGUID, Name = npcName} ) -- using a timer to clear after 30 seconds atm
	end

	if event == "PLAYER_REGEN_DISABLED" then
		self:SetAlpha(0.2)
	end

	if event == "PLAYER_REGEN_ENABLED" then
		self:SetAlpha(1.0)
		--AJ.ClearRecentTargetsTicker = C_Timer.After(30, function() AJ.RecentCombatTargets = {} AJ.Print('recent targets forgotten') end)
	end

	if event == 'LOOT_OPENED' then

		AJ.ScanLootWindow()
	end

end

local updateFrame = CreateFrame("FRAME", "AJ_OnUpdateFrame", UIParent)
updateFrame:SetScript('OnUpdate', AJ.OnUpdate)

--hooksecurefunc("ToggleWorldMap", function() AJ.UpdateWorldMapPins() end)
